export default function mockObject() {
  return new MockObjectBuilder();
}

class MockObjectBuilder {

  constructor() {
    this._factoryMethod = () => jest.fn();
  }

  usingFactory(factory) {
    this._factoryMethod = factory;
    return this;
  }
  
  fromPrototype(prototype) {
    let functions = Object.getOwnPropertyNames(prototype)
      .filter((p) => (this._isFunction(prototype[p])))
      .filter((p) => (p !== 'constructor'));
    return this.fromFunctionNames(...functions);
  }

  _isFunction(property) {
    return typeof property === 'function';
  }

  fromFunctionNames(...functionNames) {
    let mock = {};
    functionNames.forEach((fn) => mock[fn] = this._factoryMethod());
    return mock;
  }
}